"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetAllRoutes = void 0;
var path = require("path");
var React = require("react");
var react_router_dom_1 = require("react-router-dom");
var Page_1 = require("./Page");
var GetAllComponents = function (basePath) {
    if (basePath === void 0) { basePath = '/Components'; }
    var pages = [];
    var requiredComponents = require.context(basePath);
    requiredComponents.keys().forEach(function (filename) {
        if (filename.search(/js$|jsx$/) != -1) {
            var componentConfig = requiredComponents(filename);
            var componentName = filename
                .replace(/^\.\//, '')
                .replace(/\.\w+$/, '')
                .replace(/js|jsx/, '');
            var CompTag = componentConfig.default;
            pages.push(new Page_1.default("/" + componentName.toLowerCase(), componentName, CompTag));
        }
        else {
            pages = __spreadArray(__spreadArray([], pages, true), GetAllComponents(path.join(basePath, filename)), true);
        }
    });
    return pages;
};
var GetAllRoutes = function (componentDirectory) {
    if (componentDirectory === void 0) { componentDirectory = "Components"; }
    var allComponents = GetAllComponents(componentDirectory);
    var compElements = [];
    allComponents.forEach(function (page) {
        compElements.push(React.createElement(react_router_dom_1.Route, { path: page.path, element: page.component }, null));
    });
    return React.createElement(react_router_dom_1.Routes, null, compElements);
};
exports.GetAllRoutes = GetAllRoutes;
