import * as path from 'path';
import React = require('react');
import { Routes, Route } from 'react-router-dom';
import Page from './Page';

const GetAllComponents = (basePath = '/Components') : Page[] => {
    var pages: Page[] = [];

    const requiredComponents = require.context(basePath);
    requiredComponents.keys().forEach((filename: string) => {
        if (filename.search(/js$|jsx$/) != -1) {
            const componentConfig = requiredComponents(filename);
            const componentName: string = filename
                .replace(/^\.\//, '')
                .replace(/\.\w+$/, '')
                .replace(/js|jsx/, '');
            const CompTag = componentConfig.default

            pages.push(
                new Page(
                    `/${componentName.toLowerCase()}`,
                    componentName,
                    CompTag
                )
            )
        }
        else {
            pages = [...pages, ...GetAllComponents(path.join(basePath, filename))];
        }
        
    });

    return pages;
}

export const GetAllRoutes = (componentDirectory = "Components") : JSX.Element => {
    var allComponents: Page[] = GetAllComponents(componentDirectory);
    
    var compElements: JSX.Element[] = []
    allComponents.forEach(page => {
        compElements.push(React.createElement(Route, {path: page.path, element: page.component}, null))
    })

    return React.createElement(Routes, null, compElements);
}
